/* objops.h
 * header file for operations to objects
 *
 * for Denemo, a gtk+ frontend to GNU Lilypond
 * (c) 1999, 2000, 2001 Matthew Hiller
 */

#include <denemo/denemo.h>

void
freeobject (mudelaobject *mudobj);

mudelaobject *
newtimesigobj (gint time1, gint time2);

mudelaobject *
newclefobj (enum clefs type);

void
initkeyaccs (gint *accs, gint number);

mudelaobject *
newkeyobj (gint number, gboolean isminor);

mudelaobject *
newmeasurebreakobject ();

mudelaobject *
clone_object (mudelaobject * orig);

mudelaobject *
stem_directive_new (enum stemdirections type);

mudelaobject *
lily_directive_new (gchar* type);

mudelaobject *
dynamic_new (gchar *type);

mudelaobject *
lyric_new(gchar *type, gint position, gboolean syllable);

/* create one mudelaobject of type not known to denemo otherwise 
*  no object is associated. */
mudelaobject *
newobj(enum objtype type);
